; Dbut du Script
;
; Accs par Fichier > Crer > Logos > Shadowy
;
; http://www.x5ca.net/~mckay/gimp.html Jun/30/2001
; Adaptation Gimp 2 Aljacom novembre 2004
; Adaptation Gimp 2.6 Aljacom novembre 2010
(define (script-fu-shadowy inText inShadDist inShadFuz inBord inSize inFont inBGGradient inBGColr inBGTog inFGGradient inFGColr inFGTog)
	(let* 
		(
			(dummy (gimp-palette-set-foreground '(0 0 0)))

			(theImage (car (gimp-image-new 100 100 0)))

			(lA (car (gimp-text-fontname theImage -1 0 0 inText inBord TRUE inSize 0 inFont)))

			(lC (car (gimp-text-fontname theImage -1 0 0 inText inBord TRUE inSize 0 inFont)))

			(dummy (gimp-palette-set-foreground '(255 255 255)))

			(lB (car (gimp-text-fontname theImage -1 0 0 inText inBord TRUE inSize 0 inFont)))

			(lE (car (gimp-text-fontname theImage -1 0 0 inText inBord TRUE inSize 0 inFont)))

			(lF (car (gimp-text-fontname theImage -1 0 0 inText inBord TRUE inSize 0 inFont)))

			(width (car (gimp-drawable-width lA)))

			(height (car (gimp-drawable-height lA)))

			(lD (car (gimp-layer-new theImage width height 0 "Temp" 100 0)))

			(lG (car (gimp-layer-new theImage width height 0 "Temp" 100 0)))

			(lH (car (gimp-text-fontname theImage -1 0 0 inText inBord TRUE inSize 0 inFont)))

			(lOutline)

			(lOutMask)

			(lShad)

			(lShaMask)
			
			(lFGMask)

		)

		(gimp-image-resize theImage width height 0 0)

		(gimp-image-add-layer theImage lD 0)

		(gimp-image-add-layer theImage lG 0)

		(gimp-layer-set-visible lA 1)

		(gimp-layer-set-visible lB 1)

		(gimp-layer-set-visible lC 0)

		(gimp-layer-set-visible lD 0)

		(gimp-layer-set-visible lE 0)

		(gimp-layer-set-visible lF 0)

		(gimp-layer-set-visible lG 0)

		(gimp-layer-set-visible lH 0)

		(gimp-layer-set-offsets lA -1 -1)

		(gimp-layer-set-offsets lB 1 1)

		(gimp-image-lower-layer-to-bottom theImage lB)

		(set! lOutline (car (gimp-image-merge-visible-layers theImage 1)))

		(gimp-drawable-set-visible lOutline 0)

		(set! lOutMask (car (gimp-layer-create-mask lOutline 0)))

		(gimp-image-add-layer-mask theImage lOutline lOutMask)

		(gimp-layer-set-edit-mask lOutline TRUE)

		(gimp-edit-copy lC)

		(gimp-floating-sel-anchor (car (gimp-edit-paste lOutMask TRUE)))

		(gimp-image-remove-layer theImage lC)

		(gimp-layer-set-visible lD 1)

		(gimp-layer-set-visible lE 1)

		(gimp-image-lower-layer-to-bottom theImage lD)

		(gimp-layer-set-offsets lE inShadDist inShadDist)

		(gimp-palette-set-background '(0 0 0))

		(gimp-edit-clear lD)

		(set! lShad (car (gimp-image-merge-visible-layers theImage 1)))

		(gimp-layer-set-visible lShad 0)

		(plug-in-gauss-rle 1 theImage lShad inShadFuz TRUE TRUE)

		(set! lShaMask (car (gimp-layer-create-mask lShad 1)))

		(gimp-image-add-layer-mask theImage lShad lShaMask)

		(gimp-layer-set-edit-mask lShad TRUE)

		(gimp-edit-copy lF)

		(gimp-floating-sel-anchor (car (gimp-edit-paste lShaMask TRUE)))

		(gimp-layer-set-mode lShad MULTIPLY)

		(set! lFGMask (car (gimp-layer-create-mask lH 1)))

		(gimp-image-add-layer-mask theImage lH lFGMask)

		(gimp-layer-set-edit-mask lH TRUE)

		(gimp-edit-copy lF)

		(gimp-floating-sel-anchor (car (gimp-edit-paste lFGMask TRUE)))

		(gimp-image-remove-layer theImage lF)

		(gimp-palette-set-background inBGColr)

		(gimp-edit-clear lG)

		(gimp-palette-set-background inFGColr)

		(gimp-edit-clear lH)

		(gimp-edit-fill lH 1)

		(if 
			(= inBGTog TRUE)
				
				(begin

				(gimp-gradients-set-gradient inBGGradient)

				(gimp-blend lG 3 0 0 100 0 0 FALSE FALSE 0 0 0 0 0 0 height)
			)
		)

		(if 
			(= inFGTog TRUE)
				
				(begin

				(gimp-gradients-set-gradient inFGGradient)

				(gimp-blend lH 3 0 0 100 0 0 FALSE FALSE 0 0 0 0 0 0 height)
			)
		)

		(gimp-image-lower-layer-to-bottom theImage lH)

		(gimp-image-lower-layer-to-bottom theImage lG)

		(gimp-layer-set-visible lOutline 1)

		(gimp-layer-set-visible lShad 1)

		(gimp-layer-set-visible lH 1)

		(gimp-layer-set-visible lG 1)

		(gimp-display-new theImage)
	)
)

(script-fu-register "script-fu-shadowy"
	"<Image>/File/Create/Logos/Shadowy"
	"Simple hollowed out text Using Masks"
	"Terry McKay"
	"Terry McKay"
	"Feb/16/1999 - Nov/29/2010"
	""
	SF-STRING "Text String" "Gimp 2.6"
	SF-VALUE "Shadow Spacing" "3"
	SF-VALUE "Shadow Fuzziness" "5.0"
	SF-VALUE "Text Border (pixels)" "40"
	SF-VALUE "Font Size (pixels)" "60"
	SF-FONT "Font Name" "Sans Bold"
	SF-GRADIENT "Background Gradient" "Golden"
	SF-COLOR "Background Colour" '(0 0 0)
	SF-TOGGLE "Background Gradient" TRUE
	SF-GRADIENT "Foreground Gradient" "Golden"
	SF-COLOR "Foreground Colour" '(0 0 0)
	SF-TOGGLE "Foreground Gradient" TRUE
)
; Fin du Script


